# An HTTP client :sparkles: with rate limiter, retry, circuit-breaker and tor support :package: out-of-the-box

[![](https://github.com/hfreire/request-on-steroids/workflows/ci/badge.svg)](https://github.com/hfreire/request-on-steroids/actions?workflow=ci)
[![Coverage Status](https://coveralls.io/repos/github/hfreire/request-on-steroids/badge.svg?branch=master)](https://coveralls.io/github/hfreire/request-on-steroids?branch=master)
[![Known Vulnerabilities](https://snyk.io/test/github/hfreire/request-on-steroids/badge.svg)](https://snyk.io/test/github/hfreire/request-on-steroids)
[![](https://img.shields.io/github/release/hfreire/request-on-steroids.svg)](https://github.com/hfreire/request-on-steroids/releases)
[![Version](https://img.shields.io/npm/v/request-on-steroids.svg)](https://www.npmjs.com/package/request-on-steroids)
[![Downloads](https://img.shields.io/npm/dt/request-on-steroids.svg)](https://www.npmjs.com/package/request-on-steroids)

> An HTTP client with rate limiter, retry, circuit-breaker and tor support out-of-the-box.

### Features
* Uses [Perseverance](https://github.com/hfreire/perseverance) to add :raised_hand: rate limit, :poop: retry and :traffic_light: circuit breaker behaviour to your requests :white_check_mark:
* Supports [Bluebird](https://github.com/petkaantonov/bluebird) :bird: promises :white_check_mark:

### How to install
```
npm install request-on-steroids
```

### How to contribute
You can contribute either with code (e.g., new features, bug fixes and documentation) or by [donating 5 EUR](https://paypal.me/hfreire/5). You can read the [contributing guidelines](CONTRIBUTING.md) for instructions on how to contribute with code.

All donation proceedings will go to the [Sverige för UNHCR](https://sverigeforunhcr.se), a swedish partner of the [UNHCR - The UN Refugee Agency](http://www.unhcr.org), a global organisation dedicated to saving lives, protecting rights and building a better future for refugees, forcibly displaced communities and stateless people.

### Used by
* [get-me-a-date](https://github.com/hfreire/get-me-a-date) - :heart_eyes: Help me get a :cupid: date tonight :first_quarter_moon_with_face:
* [watch-rtp-play](https://github.com/hfreire/watch-rtp-play) - :tv: Watch and :radio: listen 🇵🇹 RTP Play without a :computer: browser
* [tinder-wrapper](https://github.com/hfreire/tinder-wrapper) - A :revolving_hearts: Tinder :package: wrapper library
* [happn-wrapper](https://github.com/hfreire/happn-wrapper) - A :revolving_hearts: Happn :package: wrapper library
* [mint-wrapper](https://github.com/hfreire/mint-wrapper) - A :revolving_hearts: Mint :package: wrapper library

### License
Read the [license](./LICENSE.md) for permissions and limitations.
